<?php

class Export extends Model
{
  var $Id;
  var $AnoNe = array('Ne', 'Ano');
  var $WhereLang;
  var $WhereUsers;
  var $SelectedUsers;
  var $UserNames;
  var $ClientVersion;
  var $OrderByUserList;
  var $TempDir;
  var $SourceDir;
  
  function Init()
  {
    $this->TempDir = dirname(__FILE__).'/../../'.$this->Config['Web']['TempFolder'].'Export/'.$this->Id.'/';
    if(!file_exists($this->TempDir)) mkdir($this->TempDir, 0777, true);
    $this->TempDirRelative = $this->Config['Web']['TempFolder'].'Export/'.$this->Id.'/';
    $this->SourceDir = dirname(__FILE__).'/../../'.$this->Config['Web']['SourceFolder'];
    $this->SourceDirRelative = $this->Config['Web']['SourceFolder'];
    if(!file_exists($this->SourceDir)) mkdir($this->SourceDir, 0777, true);
  }
  
  function LoadFilters()
  {  
    $DbResult = $this->Database->query('SELECT * FROM `Export` WHERE `Id`='.$this->Id);
    if($DbResult->num_rows == 0) throw new Exception('Export '.$this->Id.' neexistuje');
    $this->Export = $DbResult->fetch_assoc();   

    // Filter selected users
    $this->UserNames = '';
    $DbResult = $this->Database->query('SELECT `ExportUser`.*, `User`.`Name`, `User`.`ID` FROM `ExportUser` '.
    	'LEFT JOIN `User` ON `User`.`ID`=`ExportUser`.`User` '.
    	'WHERE `ExportUser`.`Export`='.$this->Id.' ORDER BY `ExportUser`.`Sequence`');
    while($UserLine = $DbResult->fetch_assoc())
    {
      $this->UserNames .= ', '.$UserLine['Name'];
    }
    $this->UserNames = substr($this->UserNames, 2);      
   
    if($this->Export['ClientVersion'] != '')
    {
      $DbResult = $this->Database->query('SELECT * FROM `ClientVersion` WHERE `Id`='.$this->Export['ClientVersion']);
      $this->ClientVersion = $DbResult->fetch_assoc();
    } else $this->ClientVersion = '';    
  }
  
  function BuildQuery($Group, $Columns = '', $Version = '')
  {
    global $TranslationTree, $Config;
    
    if ($Version <> '') 
      $ExportVersion = $Version;
    else
      $ExportVersion = $this->ClientVersion['BuildNumber'];
    
    $Query = 'SELECT * FROM (SELECT `T`.*, '.$Columns.'`User`.`Name` AS `UserName` FROM `'.$Group['TablePrefix'].'` AS `T`'.
    ' JOIN `ExportUser` ON (`ExportUser`.`User`=`T`.`User`) AND (`ExportUser`.`Export`='.$this->Id.') '.
    ' JOIN `User` ON `User`.`ID`=`T`.`User`'.
    ' JOIN `ExportLanguage` ON (`ExportLanguage`.`Export`='.$this->Id.')'.
    ' WHERE (`Complete` = 1) AND (`VersionStart` <= '.$ExportVersion.') AND (`VersionEnd` >= '.$ExportVersion.')'.
    ' ORDER BY `ExportLanguage`.`Sequence`, `ExportUser`.`Sequence`) AS `TT` GROUP BY `TT`.`Entry`';

    // Build columns for english texts
    $OriginalColumns = '';
    foreach($TranslationTree[$Group['Id']]['Items'] as $Column)
      $OriginalColumns .= ' `T3`.`'.$Column['Column'].'` AS `En'.$Column['Column'].'`, ';
    $OriginalColumns = substr($OriginalColumns, 0, -2);
    
    // Expand query for loading english texts
    $Query = 'SELECT `T4`.*, '.$OriginalColumns.' FROM ('.$Query.') AS `T4` '.
    ' LEFT JOIN `'.$Group['TablePrefix'].'` AS `T3` ON (`T3`.`Entry` = `T4`.`Entry`) '.
    'AND (`T3`.`Language` = '.$Config['OriginalLanguage'].') AND '.
    '(`T3`.`VersionStart` = `T4`.`VersionStart`) AND (`T3`.`VersionEnd` = `T4`.`VersionEnd`)';  

    return($Query);
  }
  
  function ExportToMangosSQL()
  {
    global $TranslationTree, $User, $Config;
  
    $this->LoadFilters();
    
    $Buffer = 
      "-- Generováno projektem wowpreklad.zdechov.net\n". 
      "-- ===========================================\n".
      "--\n".
      "-- Web projektu: ".$this->Config['Web']['Host'].$this->System->Link('/')."\n".
      "-- Datum exportu: ".date("j.n.Y  H:i:s")."\n".
      "-- Znaková sada: ".$this->Config['Database']['Charset']." / ".$this->Config['Web']['Charset']."\n".
      "-- Diakritika: ".$this->AnoNe[$this->Export['WithDiacritic']]."\n".
      "-- Vygeneroval uživatel: ".$User->Name."\n".
      "-- Vzato od uživatelů: ".$this->UserNames."\n".
      "-- Generované tabulky: ";
    
    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` '.
    	'JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      $Buffer .= $Group['TablePrefix'].', ';
    }
    $Buffer .= "\n\n";  

    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` '.
    	'JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      if($Group['MangosTable'] != '')
      {
        $Buffer .= "\n\n-- ".$Group['Name']."\n\n";
        $DbResult2 = $this->Database->query($this->BuildQuery($Group));
        if($DbResult2->num_rows > 0)
        while($Line = $DbResult2->fetch_array()) 
        {
          $Values = '';
          foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
          if($GroupItem['Column'] != $Group['PrimaryKeyItem']) // Do not update primary key
          {
            if($GroupItem['MangosColumn'] == '') $GroupItem['MangosColumn'] = $GroupItem['Column'];
            $Values .= ', `'.$GroupItem['MangosColumn'].'`="'.addslashes($Line[$GroupItem['Column']]).'"';
          }
          $Values = substr($Values, 2);

          // Get multicolumn index
          $ColumnItems = explode(',', $Group['MangosTableIndex']);
          if(count($ColumnItems) > 1) 
          {
            $Where = 'CONCAT(';
            foreach($ColumnItems as $ColumnItem)
              $Where .= '`'.$ColumnItem.'`, "_", ';
            $Where = substr($Where, 0, -7).')';
          } else $Where = '`'.$Group['MangosTableIndex'].'`';
          $Where .= ' = "'.$Line[$Group['PrimaryKeyItem']].'";'; 
          
          $Line = 'UPDATE `'.$Group['MangosTable'].'` SET '.$Values.' WHERE '.$Where;
          $Line = str_replace("\n", '\n', $Line);
          $Line = str_replace("\r", '', $Line);
          $Buffer .= $Line."\n";
        }     
      }
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    return($Buffer);
  }
  
  function ExportToAoWoWSQL() 
  {
    global $Config, $TranslationTree, $AoWoWconf;
  
    //require_once('../aowow/configs/config.php');
  
    $Buffer = $this->ExportToMangosSQL();
  
    /*
    // Data to aowow
    $Database2 = new mysqli($this->Config['Database']['Host'], $this->Config['Database']['User'], $this->Config['Database']['Password'], $this->Config['Database']['Database']);
    $Database2->query('SET NAMES '.$this->Config['Database']['Charset']);
    $Database2->select_db($AoWoWconf['mangos']['db']);    
    $AoWoWTables = array(
      'aowow_resistances' => 'Id', 
      'aowow_spelldispeltype' => 'Id', 
      'aowow_skill' => 'skillID',
    );
    foreach($AoWoWTables as $AoWoWTable => $IndexColum) 
    {
      $Buffer .= '--'.$AoWoWTable.', ';
      $Buffer .= "\n\n";  
      $Query = 'SELECT `name`,`'.$IndexColum.'` FROM `'.$AoWoWTable.'`';
      $DbResult = $Database2->query($Query);
      while($Line = $DbResult->fetch_assoc()) 
      {
        $Ori_text = $Line['name'];
        $DbResult2 = $Database2->query('SELECT `Text` AS `En`,
        (SELECT `Text` FROM `'.$Config['Database']['Database'].'`.`TextGlobalString` AS `TableTran`
         WHERE `TableEn`.`Entry` = `TableTran`.`Entry` AND (`Complete` = 1) AND '.$this->WhereLang.' AND '.$this->WhereUsers.$this->OrderByUserList.' LIMIT 1) AS `Tran`
         FROM `'.$Config['Database']['Database'].'`.`TextGlobalString` AS `TableEn` WHERE
          `Text` = "'.addslashes($Ori_text).'" LIMIT 1');
        $Tran = $DbResult2->fetch_assoc();
        //echo ($Line['name'].'='.$Tran['tran']);
        if($Tran['Tran'] == '') 
        {
          $DbResult2 = $Database2->query('SELECT `OptionText` AS `En`,
          (SELECT `OptionText` FROM `'.$this->Config['Database']['Database'].'`.`TextNPCOption` AS `TableTran`
           WHERE `TableEn`.`Entry` = `TableTran`.`Entry` AND (`Complete` = 1) AND '.$this->WhereLang.'
            AND '.$this->WhereUsers.$this->OrderByUserList.' LIMIT 1) AS `Tran`
          FROM `'.$this->Config['Database']['Database'].'`.`TextNPCOption` AS `TableEn` WHERE
            `OptionText` = "'.addslashes($Ori_text).'" LIMIT 1');
          $Tran = $DbResult2->fetch_assoc();
        }
        
        if($Tran['Tran'] <> '')
          $Buffer .= 'UPDATE `'.$AoWoWTable.'` SET `name` = "'.addslashes($Tran['Tran']).'" WHERE '.$IndexColum.' = '.$Line[$IndexColum].' ;'."\n";
      }
      $Buffer .= "\n\n";  
    }
    */
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    return($Buffer);
  }  
 
  
  function ExportToXML()
  {
    global $TranslationTree, $User;
  
    $this->LoadFilters();

    $Buffer = '<?xml version="1.0" encoding="utf-8"?>'."\n".
    "<document>\n".
    "  <meta>\n".
    "    <projecturl>".$this->Config['Web']['Host'].$this->System->Link('/')."</projecturl>\n".
    "    <time>".date('r')."</time>\n".
    "    <diacritics mode=".'"'.$this->Export['WithDiacritic'].'"'." />\n".
    "    <author>".$User->Name."</author>\n".
    "    <contributors>\n";
    foreach(explode(',', $this->UserNames) as $UserName)
      $Buffer .= "      <user>".$UserName."</user>\n";
    $Buffer .= 
    "    </contributors>\n".
    "  </meta>\n".
    "  <translation>\n";

    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` '.
    	'JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      if($Group['MangosTable'] == '')
      {
        $Group['MangosTable'] = $Group['TablePrefix'];
        $Group['MangosTableIndex'] = 'entry';
      }
      $Buffer .= '    <group id="'.$Group['Id'].'" name="'.$Group['TablePrefix'].'">'."\n";
      $DbResult2 = $this->Database->query($this->BuildQuery($Group));
      while($Line = $DbResult2->fetch_assoc()) 
      {
        $Buffer .= '      <item id="'.$Line['Entry'].'" user="'.$Line['UserName'].'">'."\n";
        $Values = '';
        foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
        {
          if($GroupItem['MangosColumn'] == '') $GroupItem['MangosColumn'] = $GroupItem['Column'];
          if($Line[$GroupItem['Column']] != '')
          $Buffer .= '        <text index="'.$GroupItem['Id'].'" name="'.
            $GroupItem['Column'].'">'.addslashes($Line[$GroupItem['Column']]).'</text>'."\n";
        }
        $Buffer .= "      </item>\n";
      }    
      $Buffer .= "    </group>\n";
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    $Buffer .= "  </translation>\n".
  "</document>";
    return($Buffer);
  }      

  function ExportToDBC()
  {
    global $TranslationTree, $Config;
  
    $this->LoadFilters();
        
    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` '.
    	'JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` '.
    	'WHERE `ExportGroup`.`Export`='.$this->Id.' AND `Group`.`DBCFileName` != ""');
    $Output = 'Počet generovaných skupin: '.$DbResult->num_rows."\n";
    while($Group = $DbResult->fetch_assoc())
    {
      $Output .= $Group['Name'].', ';
      if(file_exists($this->SourceDir.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc')) 
      {
        // Load string column index list
        $DbResult2 = $this->Database->query('SELECT * FROM `GroupItem` '.
        	'JOIN `GroupItemDBC` ON `GroupItem`.`Id` = `GroupItemDBC`.`GroupItem` AND `GroupItemDBC`.`ClientVersion` = '.$this->ClientVersion['Id'].'  WHERE `GroupItem`.`Group` = '.$Group['Id']);      
        $ColumnIndexes = array();
        $ColumnFormat = array();
        while($DbRow = $DbResult2->fetch_assoc())
        {
          $ColumnFormat[$DbRow['ColumnIndex']] = FORMAT_STRING;
          $ColumnIndexes[$DbRow['GroupItem']] = $DbRow['ColumnIndex'];
        }

        // Load all data into lookup table
        $LookupTable = array();
        $DbResult2 = $this->Database->query($this->BuildQuery($Group));
        while($DbRow = $DbResult2->fetch_assoc())
          $LookupTable[$DbRow[$Group['PrimaryKeyItem']]] = $DbRow;
      
        // Open original DBC file
        $SourceDBCFile = new DBCFile();
        $SourceDBCFile->OpenFile($this->SourceDir.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc', $ColumnFormat);
        
        // Create new DBC file
        if(!file_exists($this->TempDir.'dbc/')) mkdir ($this->TempDir.'dbc/', 0777, true);
        $NewDBCFile = new DBCFile();
        $NewDBCFile->CreateFile($this->TempDir.'dbc/'.$Group['DBCFileName'].'.dbc', $ColumnFormat);
        $NewDBCFile->SetRecordCount($SourceDBCFile->GetRecordCount());
        $NewDBCFile->SetFieldCount($SourceDBCFile->GetFieldCount());
        $NewDBCFile->Commit();

        // Replace translated strings
        $OldProgress = -1;
        $Output .= "\n\r";
        $RowCount = $SourceDBCFile->GetRecordCount();
        $FieldCount = $SourceDBCFile->GetFieldCount();        
        for($Row = 0; $Row < $RowCount; $Row++)
        {
          $Line = $SourceDBCFile->GetLine($Row);
                    
          // Get multicolumn index value
          $PrimaryKeyItem = '';
          $ColumnItems = explode(',', $Group['DBCIndex']);
          if(count($ColumnItems) > 1) 
          {
            foreach($ColumnItems as $ColumnItem)
              $PrimaryKeyItem .= $Line[$ColumnItem].'_';
            $PrimaryKeyItem = substr($PrimaryKeyItem, 0, -1);
          } else $PrimaryKeyItem = $Line[$Group['DBCIndex']];

          if(array_key_exists($PrimaryKeyItem, $LookupTable))
          {            
            // Replace text columns
            $LookupTableItem = $LookupTable[$PrimaryKeyItem];          
            foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
            {
              if(array_key_exists($GroupItem['Id'], $ColumnIndexes))
                $Line[$ColumnIndexes[$GroupItem['Id']]] = $LookupTableItem[$GroupItem['Column']];
            }
          }
          $NewDBCFile->SetLine($Row, $Line);
          
          // Show completion progress
          $Progress = round($Row / $RowCount * 100);
          if($Progress != $OldProgress)
          {
            $Output .= $Progress."%\r";
            echo($Output);
            $Output = '';
            $OldProgress = $Progress;
          }
        }   
        $NewDBCFile->Commit();              
      } else $Output .= ShowMessage('Zdrojový soubor '.$this->SourceDirRelative.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc'.' nenalezen.'."\n", MESSAGE_CRITICAL);
    }
    $Output .= 'Hotovo <br />';
    return($Output);
  }

  function ExportToLua()
  {
    global $TranslationTree;
  
    $this->LoadFilters();

    $Output = '';
    if(!file_exists($this->TempDir.'lua/')) mkdir($this->TempDir.'lua/', 0777, true);
    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id.' AND `Group`.`LuaFileName` != ""');
    while($Group = $DbResult->fetch_assoc())
    {
      $Output .= $Group['Name'].'... ';
      $File = new FileStream();
      $File->OpenFile($this->SourceDir.$this->ClientVersion['Version'].'/lua/'.$Group['LuaFileName'].'.lua');
      $File2 = new FileStream();
      $File2->CreateFile($this->TempDir.'lua/'.$Group['LuaFileName'].'.lua');
      
      $LookupTable = array();
      $DbResult2 = $this->Database->query($this->BuildQuery($Group));
      while($DbRow = $DbResult2->fetch_assoc())
        $LookupTable[$DbRow['ShortCut']] = $DbRow;
        
      while(!$File->EOF())
      {
        $Line = $File->ReadLine();
        if(strpos($Line, '=') !== false)
        {
          $LineParts = explode('=', $Line, 2);
          $Value['ShortCut'] = trim($LineParts[0]);
          $Line = trim($LineParts[1]);
          if($Line[0] == '"')
          {
            // Quoted string value
            $Line = substr($Line, 1); // Skip start qoute
            $TempLine = str_replace('\"', '  ', $Line); // Temporary remove slashed quotes
            $Value['Text'] = substr($Line, 0, strpos($TempLine, '"'));
//            $Value['Text'] = str_replace('\n', "\n", $Value['Text']);
//            $Value['Text'] = addslashes(stripslashes($Value['Text']));
            $Line = trim(substr($Line, strpos($TempLine, '"') + 1)); // Skip closing quote and semicolon                                                                  {
          } else 
          {
            // Nonstring value
            $Value['Text'] = substr($Line, 0, strpos($Line, ';'));
          }
          $Line = substr($Line, strpos($Line, ';') + 1);
          $Value['Comment'] = addslashes(stripslashes(substr($Line, 3))); // Skip " --"

          if(array_key_exists($Value['ShortCut'], $LookupTable))
          {
            $DbRow = $LookupTable[$Value['ShortCut']];
            $Value['Text'] = addslashes($DbRow['Text']);
            // Escape new line control characters
            $Value['Text'] = str_replace("\n", '\n', $Value['Text']);
            $Value['Text'] = str_replace("\r", '', $Value['Text']);
            $Value['Comment'] = $DbRow['Comment'];
            // Only one line comments allowed
            $Value['Comment'] = str_replace("\n", ' ', $Value['Comment']);
            $Value['Comment'] = str_replace("\r", '', $Value['Comment']);
            //echo('.');
          }
          $NewLine = $Value['ShortCut'].' = "'.$Value['Text'].'";';
          //if($Value['Comment'] != '') $NewLine .= ' -- '.$Value['Comment'];
          $NewLine .= "\r\n";
          $File2->WriteLine($NewLine);
        } else $File2->WriteLine($Line);
      }
      $Output .= 'Hotovo <br/>';
    }
    return($Output);
  }
}

include_once(dirname(__FILE__).'/Page.php');
include_once(dirname(__FILE__).'/ExportOutput.php');

class ModuleExport extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'Export';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Allow parametric export of translated texts to various supported output formats';
    $this->Dependencies = array();
  }
  
  function Start()
  {
  	$this->System->RegisterPage('export', 'PageExport');
  	$this->System->RegisterMenuItem(array(
    	'Title' => 'Exporty',
    	'Hint' => 'Zde si můžete stáhnout přeložené texty',
    	'Link' => $this->System->Link('/export/'),
    	'Permission' => LICENCE_ANONYMOUS,
    	'Icon' => '',
    ), 2);
  }
}

