<?php

include_once('Database.php');

class System 
{
  var $Database;
  var $Config;
  var $ModuleManager;
  var $PathItems;
  var $Menu;
  var $RSSChannels;
  
  function __construct()
  {
    $this->Config = array();
    $this->Menu = array();
    $this->RSSChannels = array();
  }
  
  function Init()
  {
  	global $Config;
  	    
    $this->Config = $Config;
    $this->Database = new Database();
    $this->Database->Connect($this->Config['Database']['Host'],
      $this->Config['Database']['User'], $this->Config['Database']['Password'],
      $this->Config['Database']['Database']);
    $this->Database->charset($this->Config['Database']['Charset']);
    $this->Database->ShowSQLQuery = $this->Config['Web']['ShowSQLQuery'];
    $this->Database->ShowSQLError = $this->Config['Web']['ShowSQLError'];
    $this->Database->LogSQLQuery = $this->Config['Web']['LogSQLQuery'];
    $this->ModuleManager = new AppModuleManager();

    $this->Menu = array
    (    		
    		array(
    				'Title' => 'Stav dokončení',
    				'Hint' => 'Stav dokončení překládů',
    				'Link' => $this->Link('/statistic.php'),
    				'Permission' => LICENCE_ANONYMOUS,
    				'Icon' => '',
    		),
    		array(
    				'Title' => 'Soubory',
    				'Hint' => 'Stahování různých pomocných souborů a programů',
    				'Link' => $this->Link('/download.php'),
    				'Permission' => LICENCE_ANONYMOUS,
    				'Icon' => '',
    		),
    		array(
    				'Title' => 'Pokyny',
    				'Hint' => 'Informace k překladu hry',
    				'Link' => $this->Link('/info.php'),
    				'Permission' => LICENCE_ANONYMOUS,
    				'Icon' => '',
    		),
    		array(
    				'Title' => 'Zdroje dat',
    				'Hint' => 'Informace o překladových skupinách',
    				'Link' => $this->Link('/TranslationList.php?action=grouplist'),
    				'Permission' => LICENCE_ANONYMOUS,
    				'Icon' => '',
    		),
    		array(
    				'Title' => 'Prezentace',
    				'Hint' => 'Prezentace a motivace překladu',
    				'Link' => $this->Link('/promotion.php'),
    				'Permission' => LICENCE_ANONYMOUS,
    				'Icon' => '',
    		),    		
    		array(
    				'Title' => 'IRC chat',
    				'Hint' => 'IRC chat pro překladatele',
    				'Link' => 'http://embed.mibbit.com/?server=game.zdechov.net%3A6667&amp;channel=%23wowpreklad&amp;forcePrompt=true&amp;charset=utf-8',
    				'Permission' => LICENCE_ANONYMOUS,
    				'Icon' => '',
    		),
    		array(
    				'Title' => 'Správa',
    				'Hint' => 'Volby pro správu',
    				'Link' => $this->Link('/admin/'),
    				'Permission' => LICENCE_ADMIN,
    				'Icon' => '',
    		),
    );
    
  }
  
  function GetMicrotime()
  {
    list($Usec, $Sec) = explode(' ', microtime());
    return ((float)$Usec + (float)$Sec);
  }
  
  function Link($Target)
  {
    return($this->Config['Web']['BaseURL'].$Target);
  } 
  
  function RegisterPage($Path, $Handler)
  {
  	if(is_array($Path))
    {
      $Page = &$this->Pages;
      $LastKey = array_pop($Path);
      foreach($Path as $PathItem)
      {
        $Page = &$Page[$PathItem];       
      }
      if(!is_array($Page)) $Page = array('' => $Page);
      $Page[$LastKey] = $Handler;
    } else $this->Pages[$Path] = $Handler;
  }
  
  function RegisterMenuItem($MenuItem, $Pos = NULL)
  {
  	if(is_null($Pos)) $this->Menu[] = $MenuItem;
  	  else {
  	  	array_splice($this->Menu, $Pos, 0, array($MenuItem));
  	  }
  }
  
  function RegisterRSS($Channel, $Pos = NULL)
  {
  	if(is_null($Pos)) $this->RSSChannels[] = $Channel;
  	  else {
  	  	array_splice($this->RSSChannels, $Pos, 0, array($Channel));
  	  }
  }
  
  function SearchPage($PathItems, $Pages)
  {
    if(count($PathItems) > 0) $PathItem = $PathItems[0];
      else $PathItem = '';
    if(array_key_exists($PathItem, $Pages))
    {
      if(is_array($Pages[$PathItem])) 
      {
        array_shift($PathItems);
        return($this->SearchPage($PathItems, $Pages[$PathItem]));
      } else return($Pages[$PathItem]);
    } else return('');
  }
  
  function PageNotFound()
  {
    return('Page '.implode('/', $this->PathItems).' not found.');
  }
  
  function ShowPage()
  {
    /* @var $Page Page */
    $ClassName = $this->SearchPage($this->PathItems, $this->Pages);     
    if($ClassName != '') 
    {
      $Page = new $ClassName($this);
      $Page->GetOutput();
    } else echo($this->PageNotFound());
  }
} 
